// This file is part of the utui library, a terminal UI framework.
//
// Copyright (C) 2006 by Mike Sharov <msharov@users.sourceforge.net>
// This file is free software, distributed under the MIT License.
//
// autowig.h
//

#ifndef AUTOWIG_H_731692C640F19E6153B6631938EE5396
#define AUTOWIG_H_731692C640F19E6153B6631938EE5396

#include "doccli.h"

//----------------------------------------------------------------------
// Automatic widget creation definitions.

/// Initialization value for autogenerated widgets.
union SWidgetInitValue {
    unsigned long	lv;
    const void*		p;
    const char*		text;
    uint8_t		ab[4];
    uint16_t		aw[2];
};
typedef unsigned long	widivbase_t;

/// A widget is a window or a layout item, generated by a factory.
class CLayout;
typedef CLayout*		pwidget_t;
typedef const SWidgetInitValue	widival_t;
/// Widget factories autocreate widgets for building dialog from widget descriptor arrays.
typedef pwidget_t	(*pfnWidgetFactory_t)(widival_t v);

/// A description from which a widget could be autogenerated.
/// Arrays of this type define dialog layouts.
struct SWidgetDesc {
    size_t		nChildren;	///< Number of child widgets.
    pfnWidgetFactory_t	pfnFactory;	///< Factory function to create the widget object.
    SWidgetInitValue	initValue;	///< Initialization value to pass to pfnFactory.
};

typedef const SWidgetDesc*	pcwidesc_t;

/// Standard dyncrate factory for widgets declared in dialog description arrays.
template <typename T>
pwidget_t TWidgetFactory (widival_t v)
    { return (new T (v)); }

//----------------------------------------------------------------------

#define BEGIN_DIALOG_DESC(name)	\
    static const SWidgetDesc name[] = {
#define END_DIALOG_DESC		\
	{ 0, NULL, { 0 } }	\
    };

#define WIDIVAL_PTR(t)		{widivbase_t((void*)(t))}
#define WIDIVAL_TEXT(t)		WIDIVAL_PTR(static_cast<const char*>(t))
#if USTL_BYTE_ORDER == USTL_LITTLE_ENDIAN
    #define WIDIVAL_AB(a,b,c,d)	{widivbase_t(((d) << 24) | ((c) << 16) | ((b) << 8) | (a))}
    #define WIDIVAL_AW(a,b)	{widivbase_t(((b) << 16) | (a))}
#else
    #define WIDIVAL_FIRST_4B_OFFSET	(BitsInType(widivbase_t) - 32)
    #define WIDIVAL_AB(a,b,c,d)	{widivbase_t((((a) << 24) | ((b) << 16) | ((c) << 8) | (d)) << WIDIVAL_FIRST_4B_OFFSET)}
    #define WIDIVAL_AW(a,b)	{widivbase_t((((a) << 16) | (b)) << WIDIVAL_FIRST_4B_OFFSET)}
#endif

//----------------------------------------------------------------------

#endif

